
ClassificationCache.prototype = new AccountFile();

function ClassificationCache(account){

	this.initialize(account, "classifications.cache");
	
	this.write=function(out){
		for(m in this.account.mail){		
			msg=this.account.mail[m];
			if(msg){
				var msguri=m;
				
				if(msg.isClassified()){
					var flduri=msg.getBest().mozillaFolder.URI;
				} else {
					var flduri = "null";
				}
			
				var msgHdr = null;
				try{msgHdr = this.messenger.msgHdrFromURI(msguri)} 
				catch(e){dump(e);}
				if(msgHdr!=null){
					out.write(msguri,msguri.length);
					out.write(",",1);
					out.write(flduri,flduri.length);
					out.write("\n",1);
				}
			}
		}
	}	
	this.read=function(inp){
		while(inp.available()){
			var ch="";
			var mail="";
			var folder="";
			while(ch!=","){
				mail+=ch;
				ch=inp.read(1);
			}
			ch="";
			while(ch!="\n"){
				folder+=ch;
				ch=inp.read(1);
			}
			if(mail && folder && mail.length>0 && folder.length>0){
				this.account.setClassificationFor(mail,folder);
			}
		}
	}
}
