
function Messages(dialog){
	this.current = new Array()
	this.toClass = new Array()
	this.folders = new Array();
	this.dialog = dialog;

	this.toClassify = function(uri,folder){
		this.toClass.push(uri);
		this.folders.push(folder);
	}

	this.classified = function(msguri){
		len1 = this.current.length;		
		for(i=0;i<this.current.length;i++){
			if (this.current[i] == msguri){
				this.current.splice(i,1);
				break;
			}
		}
		len2 = this.current.length;	
		
		if (len2<len1) this.dialog.remove(1);
		if(len1>0  && len2==0){
			if(this.toClass.length>0 && !this.stopped) this.start1();
			else this.dialog.start(this.name);
		}
	}

	this.action = function(a,b){

	}

	this.start1 = function(){
		this.current = new Array();
		for(i=0;i<5 && this.toClass.length>0;i++){
			uri = this.toClass.shift();
			folder = this.folders.shift();
			this.current.push(uri);
			this.action(uri,folder);
		}
	}

	this.addToDialog = function(){
		// elimino i duplicati
		for(i=0;i<this.toClass.length;i++){
			for(j=i+1;j<this.toClass.length;j++){
				if(this.toClass[i] == this.toClass[j]){
					this.toClass.splice(j,1);
					this.folders.splice(j,1);
				}
			}	
		}
		this.dialog.add(this.toClass.length);
	}	

	this.start = function(){
		if(this.toClass.length==0) this.dialog.start(this.name);		
		this.start1();
	}
}

function ClassifyMessages(dialog){
	Messages.call(this,dialog);
	this.name = "classMess";

	this.action = function(a,b){
		controller.forceClassify(a,b);
	}
}

function SetClassificationMessages(dialog){
	Messages.call(this,dialog);
	this.name = "setClass";

	this.action = function(a,b){
		controller.setClassification(a,b);
	}
}

function ProgressDialog(attachOnQuit){
	if(attachOnQuit==undefined) attachOnQuit = true;
	
	this.dialog = null;
	this.remaining = 0
	this.tot = 0;
	this.perc = 0;
	this.menu = document.getElementById('MCMenu');
	this.classMess = new ClassifyMessages(this);
	this.setClass = new SetClassificationMessages(this);
	this.toolbarPanel = document.getElementById('mcStatusBar');
	this.progressBar = document.getElementById('classification-meter');
	this.progressLabel = document.getElementById('classification-label');
	this.observerService = observerService;
	this.saveClassification = new SaveClassification(this);

	this.show = function(){
		this.toolbarPanel.setAttribute("hidden","false");
		this.dialog = true;		
		this.menu.setAttribute("disabled","true");
		//this.dialog = openDialog("chrome://mailclassifier/content/progressdialog.xul", "Attendere", "chrome,titlebar,close=no,dialog,resizable=no,dependent=yes,centerscreen,width=430,height=130",this);
	}
	
	this.hide = function(){
		if(this.dialog){
   		        //this.dialog.close();
			this.toolbarPanel.setAttribute("hidden","true");
			this.menu.setAttribute("disabled","false");
		}
		this.dialog = null;
		mcProgDialog = new ProgressDialog(false);
		mcProgDialog.save();
		mcProgDialog = null;
		
		this.observerService.removeObserver(this,"quit-application");
	}

	this.update = function(){
		this.progressBar.value = this.perc;
		this.progressLabel.value = (this.tot-this.remaining) + "/" + this.tot;
	}

	this.add = function(n){
		this.tot += n;
		this.remaining += n;
	}

	this.remove = function(n){
		this.remaining -= n;
		if(this.remaining<0) this.remaining=0;
		
		this.perc = (1 - (this.remaining / this.tot)) * 100;
		this.update();		
	}

	this.start = function(status){		
		if(this.stopped){
			//this.hide();
		}
		else if(!status){
			 this.show();
			 this.setClass.addToDialog();
			 this.classMess.addToDialog();
			 this.current = this.setClass;
			 this.update();
			 this.setClass.start();
		}
		else if (status=="setClass"){
			this.current = this.classMess;
			this.classMess.start();
		}
		else if(status=="classMess"){
			if(this.tot>0) controller.writeData();
			this.hide();
		}
	}
	
	this.stop = function(){
		if(this.current){
			this.stopped=true;
			this.current.stopped=true;
			this.hide();	
		}
	}

	this.classified = function(msguri){
		this.current.classified(msguri)
	}

	this.save = function(){
		this.saveClassification.save();
	}

	this.load = function(){
		this.saveClassification.load();
	}	

	this.observe=function(subject,topic,data){
		if(topic=="quit-application"){
			this.save();
		}
	}

	if(attachOnQuit) observerService.addObserver(this,"quit-application",false);

}

function mcAddAccountForTraining(account){
	ufolders = getUserFolders(account);
	for(folder in ufolders){
		folder = ufolders[folder].mozillaFolder
		if(!controller.getExcluded(folder)){		
			try{
				messages = folder.getMessages(msgWindow);
				while(messages.hasMoreElements()){
					msg = messages.getNext().QueryInterface(Components.interfaces.nsIMsgDBHdr)
					uri = folder.getUriForMsg(msg)				
					mcProgDialog.setClass.toClassify(uri,folder);		
				}
			}
			catch(e){}
		}
	}	
}

function mcAddAccountForClassification(account){
	try{	
		var folder = account.getInbox()
		messages = folder.getMessages(msgWindow);
		while(messages.hasMoreElements()){
			msg = messages.getNext().QueryInterface(Components.interfaces.nsIMsgDBHdr)
			uri = folder.getUriForMsg(msg)
			mcProgDialog.classMess.toClassify(uri,folder.server);		
		}
	}
	catch(e){}
}

function classifications(accounts,training,inbox){
	mcProgDialog = new ProgressDialog();
	i=0;
	for(acc in accounts){
		if(accounts[acc].uFolders.length>0){
			if(training[i]){
				mcAddAccountForTraining(acc);
			}
			if(inbox[i]){
				mcAddAccountForClassification(accounts[acc]);
			}
		}
		i++;
	}
	controller.resetTrainingData();
	mcProgDialog.start();
}

function loadClassifications(){
	mcProgDialog = new ProgressDialog();
	mcProgDialog.load();
	mcProgDialog.start();
}

mcProgDialog = null;
