
SaveClassification.prototype = new File()

function SaveClassification(dialog){
	this.dialog = dialog;
	this.initialize(null, "savedClassification.txt");

	this.writeUris = function(uris, out, folders){
		for(i in uris){
			out.write(uris[i], uris[i].length);
			if(folders){
				out.write(',',1);
				var flduri = folders[i].URI;
				out.write(flduri,flduri.length);			
			}
			out.write("\n", 1);
		}
	}

	this.write=function(out){
		var tot = dialog.tot + "";
		var remaining = dialog.remaining + "";
		var uris;		
		out.write(remaining, remaining.length);
		out.write("/",1);
		out.write(tot, tot.length);
		out.write("\n",1);
		uris = this.dialog.setClass.toClass;
		folders = this.dialog.setClass.folders;
		this.writeUris(uris,out,folders);		
		out.write("---\n", 4);
		uris = this.dialog.classMess.toClass;
		this.writeUris(uris,out);
		out.write("---\n", 4);	
	}

	this.readLine = function(inp){
		var ch=""
		var line="";
		while(ch!="\n"){
			line+=ch;
			ch=inp.read(1);
		}
		return line;				
	}

	this.readPerc = function(inp){
		var ch=""
		var tot="";
		var line = this.readLine(inp);
		line = line.split('/');		
		this.dialog.tot = line[1] - line[0];
	}	

	this.readUris = function(inp){
		var line="";
		var ret = [];		
		while(true){
			line = this.readLine(inp);
			if(line=='---') break;
			ret.push(line);
		}
		return ret;
	}

	this.read=function(inp){
		try{
			while(inp.available()){
				this.readPerc(inp);
				var uris = this.readUris(inp);
				for(i in uris){
					var app = uris[i].split(",");
					if(app.length==2){
						var folder = GetMsgFolderFromUri(app[1]);
						if(folder){
							this.dialog.setClass.toClassify(app[0], folder);
						}					
					}
				}
				var uris = this.readUris(inp);
				for(i in uris){
					if(uris[i].length>0) this.dialog.classMess.toClassify(uris[i], messenger.msgHdrFromURI(uris[i]).folder.server);				
				}
			}
		} catch(e){}
	}

}
